
package de.ivu.elect.presentation.wahl;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.wahl.entity.WahlParameter;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.wahl.form.WahlParameterViewFormBuilder;

@OnlineHilfeId(value = "636", mehrfachVergebenOk = true)
@Named(AbstractWahlParameterEditView.COMPONENT_NAME)
public class WahlParameterEditView extends AbstractWahlParameterEditView {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient WahlParameterViewFormBuilder wahlParameterViewFormBuilder;

  public WahlParameterEditView() {
    super();
  }

  @Override
  protected boolean isGebietBearbeitenRechtPruefen() {
    return false;
  }

  @Override
  public void addProperties(FormBuilder formBuilder, WahlParameter wahlParameter) {
    wahlParameterViewFormBuilder.addProperties(formBuilder, wahlParameter);
  }

  @Override
  public boolean isBtnSaveRendered() {
    return super.isBtnSaveRendered() && !isReadonlyParameter();
  }

  private boolean isReadonlyParameter() {
    return isEntitySet() && getEntity().getWertTyp().expectsWertIsReadonly();
  }
}
